﻿#include <iostream>
#include <string>
#include <fstream>
#include <algorithm>
#include <ranges>
#include "MeshLoader.h"
#include "AneuMeshLoader.h"

//!!! Задание на защиту (не удалять!) ВЫПОЛНЕНО
//!!! Реализовать на основе ranges
//!!! 1. Отсортировать тетраэдры по их качеству, определяемому как отношение наименьшей высоты к наибольшей грани тетраэдра.
//!!! 2. Отобрать первые 10 и вывести в файл с помощью потокового итератора списки ID их вершин.


int main() {
    const std::string FILEPATH = "1";
    MeshLoader* loader = new AneuMeshLoader; //!! ИСПАВЛЕНО Утечка памяти
    std::vector<FiniteElement> elems;
    std::vector<Node> nodes;
    std::vector<std::vector<Node>> neighbors;
    std::vector<BoundaryFiniteElement> surfaces;

    loader->LoadMesh("1");

    std::cout << "PrintData test:" << std::endl;
    loader->Print_Data();

    std::cout << "findFE" << std::endl;
    elems = loader->findFE(1, 2, 3);
    std::cout << elems << std::endl;
    elems.clear();

    std::cout << "findEdge" << std::endl;
    elems = loader->findEdge(1, 2);
    for (const auto& x : elems)  //!!! ИСПРАВЛЕНО Вы x меняете в цикле? Где const 
    std::cout << x << std::endl;
    elems.clear();

    std::cout << "getSurfaceID" << std::endl;
    nodes = loader->getSurfaceID(1);
    std::cout << nodes << std::endl;
    nodes.clear();

    std::cout << "getBoundaryFiniteID" << std::endl;
    surfaces = loader->getBoundaryFiniteID(1);
    std::cout << surfaces << std::endl;
    surfaces.clear();

    std::cout << "InsertNewNodes" << std::endl;
    loader->InsertNewNodes();
    loader->Print_Data();
    delete(loader);
    return 0;
}
